//Talkzone v2.1 by Joe 'Pinkfairie' Maley:

//Terminate:
#pragma semicolon 1

//Includes:
#include <sourcemod>
#include <sdktools>

//Definitions:
#define SAYDIST 600
#define YELLDIST 1000
#define WHISPDIST 150

//Variables:
static bool:DisableOOC = false;

//Calling:
static Connected[33];
new bool:Answered[33] = false;

//Timers:
static TimeOut[33];

//Calling:
stock Call(Client, Player)
{

	//World:
	if(Client != 0 && Player != 0)
	{

		//Declare:
		decl String:PlayerName[32];

		//Initialize:
		GetClientName(Player, PlayerName, sizeof(PlayerName));

		//Not Connected:
		if(Connected[Player] == 0)
		{

			//Initialize:
			Connected[Client] = Player;
			Connected[Player] = Client;
	
			//Print:
			PrintToChat(Client, "[RP] You call %s...", PlayerName);

			//Send:
			RecieveCall(Player);
			TimeOut[Client] = 40;
			CreateTimer(1.0, TimeOutCall, Client);

		}
		else
		{

			//Print:
			PrintToChat(Client, "[RP] %s is already on the phone", PlayerName);
		}
	}
}

//Recieve:
stock RecieveCall(Client)
{

	//Sound:
	EmitSoundToClient(Client, "roleplay/ring.wav", SOUND_FROM_PLAYER, 5);

	//Print:
	PrintToChat(Client, "[RP] Your phone is ringing, Type /answer to recieve the call");

	//Send:
	TimeOut[Client] = 40;
	CreateTimer(1.0, TimeOutRecieve, Client);
}

//Answer:
stock Answer(Client)
{

	//Connected:
	if(!Answered[Client] && Connected[Client] != 0)
	{

		//Declare:
		decl Player;
		decl String:ClientName[32];
	
		//Initialize:
		Player = Connected[Client];
		GetClientName(Client, ClientName, sizeof(ClientName));

		//Print:
		PrintToChat(Client, "[RP] You answer your phone");
		PrintToChat(Player, "[RP] %s answered their phone", ClientName);
	
		//Send:
		Answered[Client] = true;
		Answered[Player] = true;

		//Sound:
		StopSound(Client, 5, "roleplay/ring.wav");
	}
	else
	{

		//Print:
		PrintToChat(Client, "[RP] You already answered the phone");
	}
}

//Hang Up:
stock HangUp(Client)
{

	//Connected:
	if(Connected[Client] != 0)
	{

		//Declare:
		decl Player;
		decl String:ClientName[32], String:PlayerName[32];
	
		//Initialize:
		Player = Connected[Client];
		GetClientName(Client, ClientName, sizeof(ClientName));
		GetClientName(Player, PlayerName, sizeof(PlayerName));

		//Print:
		PrintToChat(Client, "[RP] You hang up on %s", PlayerName);
		PrintToChat(Player, "[RP] %s hung up on you", ClientName);
	
		//Send:
		Connected[Client] = 0;
		Answered[Client] = false;
		Connected[Player] = 0;
		Answered[Player] = false;

		//Sound:
		StopSound(Client, 5, "roleplay/ring.wav");
	}
	else
	{

		//Print:
		PrintToChat(Client, "[RP] You are not on the phone");
	}
}

//Silent:
stock PrintSilentChat(Client, String:ClientName[32], Player, String:Message[32], String:Arg[255])
{

	//Print:
	PrintToChat(Client, "(%s) %s: %s", Message, ClientName, Arg);
	PrintToChat(Player, "(%s) %s: %s", Message, ClientName, Arg);
}

//Chat:
stock PrintRPChat(Client, String:ClientName[32], String:Message[32], String:Arg[255], ArgNumber, ChatDist, bool:RegChat = false)
{

	//Declare:
	decl MaxPlayers;
	decl Float:ClientOrigin[3];
	
	//Initialize:
	MaxPlayers = GetMaxClients();
	GetClientAbsOrigin(Client, ClientOrigin);

	//Players:
	for(new X = 1; X < MaxPlayers; X++)
	{

		//Loop:
		if(X != Client && IsClientConnected(X) && IsClientInGame(X))
		{

			//Declare:
			decl Float:Distance, Float:PlayerOrigin[3];

			//Initialize:
			GetClientAbsOrigin(X, PlayerOrigin);
			Distance = GetVectorDistance(ClientOrigin, PlayerOrigin);

			//Print:
			if(RegChat) if(Distance <= ChatDist) PrintToChat(X, "%s: %s", ClientName, Arg[ArgNumber]);
			else if(Distance <= ChatDist) PrintToChat(X, "(%s) %s: %s", Message, ClientName, Arg[ArgNumber]);
		}
	}

	//Close:
	if(RegChat) PrintToChat(Client, "%s: %s", ClientName, Arg[ArgNumber]);
	else PrintToChat(Client, "(%s) %s: %s", Message, ClientName, Arg[ArgNumber]);
}

//In-Game:
public OnClientPutInServer(Client)
{

	//Default:
	Connected[Client] = 0;
	Answered[Client] = false;
	TimeOut[Client] = 0;
}

//Disconnect:
public OnClientDisconnect(Client)
{

	//Connected:
	if(Connected[Client] != 0)
	{

		//Declare:
		decl Player;

		//Initialize:
		Player = Connected[Client];

		//Print:
		PrintToChat(Player, "[RP] You have lost service, phone conversation aborted");
	
		//Send:
		Connected[Client] = 0;
		Answered[Client] = false;
		Connected[Player] = 0;
		Answered[Player] = false;
	}
}

//Time Out (Calling):
public Action:TimeOutCall(Handle:Timer, any:Client)
{
	
	//Push:
	if(TimeOut[Client] > 0) TimeOut[Client] -= 1;

	//Broken Connection:
	if(Connected[Client] == 0)
	{

		//End:
		TimeOut[Client] = 0;
	}

	//Not Answered:
	if(!Answered[Client] && TimeOut[Client] == 1)
	{

		//Declare:
		decl Player;
		decl String:PlayerName[32];
	
		//Initialize:
		Player = Connected[Client];
		GetClientName(Player, PlayerName, sizeof(PlayerName));

		//Print:
		PrintToChat(Client, "[RP] %s failed to answer their phone", PlayerName);

		//End Connection:
		Answered[Client] = false;
		Connected[Client] = 0;	
	}

	//Loop:
	if(TimeOut[Client] > 0)
	{

		//Send:
		CreateTimer(1.0, TimeOutCall, Client);
	}
}

//Time Out (Recieve):
public Action:TimeOutRecieve(Handle:Timer, any:Client)
{

	//Push:
	if(TimeOut[Client] > 0) TimeOut[Client] -= 1;

	//Broken Connection:
	if(Connected[Client] == 0)
	{

		//End:
		TimeOut[Client] = 0;
	}

	//Not Answered:
	if(!Answered[Client] && TimeOut[Client] == 1)
	{

		//Print:
		PrintToChat(Client, "[RP] Your phone has stopped ringing");

		//End Connection:
		Answered[Client] = false;
		Connected[Client] = 0;
	}

	//Loop:
	if(TimeOut[Client] > 0)
	{

		//Send:
		CreateTimer(1.0, TimeOutRecieve, Client);
	}
}

//Handle Chat:
public Action:CommandSay(Client, Arguments)
{

	//World:
	if(Client == 0) return Plugin_Handled;

	//Declare:
	decl String:Arg[255];

	//Initialize:
	GetCmdArgString(Arg, sizeof(Arg));

	//Clean:
	StripQuotes(Arg);
	TrimString(Arg);

	//Name:
	new String:ClientName[32];
	GetClientName(Client, ClientName, 32);

	//Answer:
	if(StrContains(Arg, "/answer", false) == 0)
	{

		//Answer:
		Answer(Client);
	}

	//Hangup:
	if(StrContains(Arg, "/hangup", false) == 0)
	{

		//Call:
		HangUp(Client);
	}

	//Call:
	if(StrContains(Arg, "/call ", false) == 0)
	{

		//Already Connected:
		if(Connected[Client] != 0) return Plugin_Handled;

		//Dead:
		if(!IsPlayerAlive(Client)) return Plugin_Handled;

		//Declare:
		decl Player, MaxPlayers;
		decl String:ArgBuffers[2][32], String:TempName[32];

		//Explode:
		ExplodeString(Arg, " ", ArgBuffers, 2, 32);

		//Initialize:
		Player = -1;
		MaxPlayers = GetMaxClients();
	
		//Find:
		for(new X = 1; X <= MaxPlayers; X++)
		{

			//Connected:
			if(!IsClientConnected(X)) continue;

			//Initialize:
			GetClientName(X, TempName, sizeof(TempName));

			//Save:
			if(StrContains(TempName, ArgBuffers[1], false) != -1) Player = X;
		}
	
		//Invalid Name:
		if(Player == -1)
		{

			//Print:
			PrintToChat(Client, "[RP] Could not find client %s", ArgBuffers[1]);

			//Return:
			return Plugin_Handled;
		}

		//Yourself:
		if(Player == Client)
		{

			//Print:
			PrintToChat(Client, "[RP] You cannot call yourself");

			//Return:
			return Plugin_Handled;
		}

		//Dead:
		if(!IsPlayerAlive(Player))
		{

			//Print:
			PrintToChat(Client, "[RP] Cannot call a dead player");

			//Return:
			return Plugin_Handled;
		}

		//Call:
		Call(Client, Player);

		//Return:
		return Plugin_Handled; 
	}

	//RP Commands:
	if(Arg[0] == '/') return Plugin_Handled;

	//OOC:
	if(StrContains(Arg, "ooc ", false) == 0)
	{

		//Print:
		if(!DisableOOC) PrintToChatAll("(OOC) %s: %s", ClientName, Arg[4]);
		else PrintToChat(Client, "[RP] OOC is disabled right now.");

		//Return:
		return Plugin_Handled; 
	}


	//Phone:
	if(Connected[Client] != 0)
	{

		//On the Phone:
		if(Answered[Client])
		{

			//Print:
			PrintSilentChat(Client, ClientName, Connected[Client], "Phone", Arg);

			//Return:
			return Plugin_Handled;
		}
	}

	//Yell:
	if(StrContains(Arg, "yell ", false) == 0)
	{
	
		//Print:
		PrintRPChat(Client, ClientName, "Yell", Arg, 5, YELLDIST);

		//Close:
		return Plugin_Handled;
	}

	//Whisper:
	if(StrContains(Arg, "whisper ", false) == 0)
	{

		//Print:
		PrintRPChat(Client, ClientName, "Whisper", Arg, 8, WHISPDIST);

		//Close:
		return Plugin_Handled;
	}

	//Say:
	PrintRPChat(Client, ClientName, "EasterEgg", Arg, 0, SAYDIST, true);

	//Close:
	return Plugin_Handled;  
}      

//Team Chat:
public Action:CommandSayTeam(Client, Arguments)
{

	//World:
	if(Client == 0) return Plugin_Handled;

	//Declare:
	decl String:Arg[255];

	//Initialize:
	GetCmdArgString(Arg, sizeof(Arg));

	//Clean:
	StripQuotes(Arg);
	TrimString(Arg);

	//Name:
	new String:ClientName[32];
	GetClientName(Client, ClientName, 32);

	//Admin-Say:
	if(Arg[0] == '@') return Plugin_Handled;

	//Print:
	if(!DisableOOC) PrintToChatAll("(OOC) %s: %s", ClientName, Arg);
	else PrintToChat(Client, "[RP] OOC is disabled right now.");

	//Return:
	return Plugin_Handled; 
}

//Death:
public Action:EventDeath(Handle:Event, const String:Name[], bool:Broadcast)
{

	//Declare:
	decl Client;

	//Initialize:
	Client = GetClientOfUserId(GetEventInt(Event, "userid"));

	//Hangup:
	if(Connected[Client] != 0) HangUp(Client);
}

//OOC:
public Action:CommandOOC(Client, Args)
{

	//Check:
	if(Args < 1)
	{

		//Print:
		PrintToConsole(Client, "[RP] Usage: sm_ooc <0|1>");

		//Print:
		return Plugin_Handled;
	}

	//Declare:
	decl iFlag;
	decl String:Flag[32];

	//Initialize:
	GetCmdArg(1, Flag, sizeof(Flag));
	StringToIntEx(Flag, iFlag);
	
	//Invalid Id:
	if(iFlag != 0 && iFlag != 1)
	{

		//Print:
		PrintToConsole(Client, "[RP] Flag must be above 0 or 1");

		//Return:
		return Plugin_Handled;
	}

	//Disable:
	if(iFlag == 0)
	{

		//Turn Off:
		DisableOOC = true;

		//Print:
		PrintToChatAll("[RP] OOC Disabled");
	}

	//Enable:
	if(iFlag == 1)
	{

		//Turn On:
		DisableOOC = false;

		//Print:
		PrintToChatAll("[RP] OOC Enabled");
	}

	//Return:
	return Plugin_Handled;
}

//Map Start:
public OnMapStart()
{

	//Precache:
	PrecacheSound("roleplay/ring.wav", true);
	AddFileToDownloadsTable("sound/roleplay/ring.wav");
}

//Information:
public Plugin:myinfo =
{

	//Initation:
	name = "Talkzone",
	author = "Joe 'Pinkfairie' Maley",
	description = "Talkzone for RP",
	version = "2.1",
	url = "hiimjoemaley@hotmail.com"
}

//Initation:
public OnPluginStart()
{

	//Commands:
	RegConsoleCmd("say", CommandSay);
	RegConsoleCmd("say_team", CommandSayTeam);

	//Disable:
	RegAdminCmd("sm_ooc", CommandOOC, ADMFLAG_CUSTOM3, "<0|1> - Disabled/Enables OOC.");

	//Server Variable:
	CreateConVar("talkzone_version", "2.1", "Talkzone Version",FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_UNLOGGED|FCVAR_DONTRECORD|FCVAR_REPLICATED|FCVAR_NOTIFY);
}